//+------------------------------------------------------------------+
//|    TRO_AggregateTrend                        Aggregate Trend.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, S M Jones"
#property link      "sjcoinc2000@yahoo.com"

#property indicator_chart_window

extern int myCorner = 0 ;
extern int myChartY = 100 ;

extern int myChartPeriod = 0 ;
extern int myBars        = 24 ;

extern string myFont  = "Courier" ; // "Verdana"
extern int myFontSize = 12 ; //9
 
extern color myColorH = LightSalmon ;
extern color myColor1 = LightSalmon ;
extern color myColor2 = LightSalmon ;
extern color myColor3 = LightSalmon ;
extern color myColor4 = LightSalmon ;
extern color myColor5 = LightSalmon ;
extern color myColor6 = LightSalmon ;
extern color myColor7 = LightSalmon ;
extern color myColor8 = LightSalmon ;
extern color myColor9 = LightSalmon ;
extern color myColor10 = LightSalmon ;
extern color myColor11 = LightSalmon ;
extern color myColor12 = LightSalmon ;
extern color myColor13 = LightSalmon ;



extern int     ATRTimeFrame = 0; // In minutes
extern int     ATRShort = 20;    // Short term 
extern int     ATRLong = 250;   // Longer term
extern int     PeriodSize = 5; // Time Frame
extern int     BarCount = 48; // Look back period
extern double  Factor = 1.1;  // What is the beginning of a trend 1.1:1



string S01,S02,S03,S04,S05 ,S06 , S07 , S08, S09, S10, S11, S12, S13; 

string symbol, tChartPeriod ;  

int    digits, period, win ; 

double point, open, high, low, close ;  
double X01,X02,X03,X04,X05 ;
double X06 ;   
double X07 ;
double X08, X09, X10, X11, X12, X13; 

string dHead01, dHead02;
string dLabel01, dValue01;
string dLabel02, dValue02;
string dLabel03, dValue03;
string dLabel04, dValue04;
string dLabel05, dValue05;
string dLabel06, dValue06;
string dLabel07, dValue07;
string dLabel08, dValue08;
string dLabel09, dValue09;
string dLabel10, dValue10;
string dLabel11, dValue11;
string dLabel12, dValue12;
string dLabel13, dValue13;



    int i,Strength, brokerhour,brokermin, brokersecond;
    double up, down, o, h, l, c,Range,temp,ratio,ATR,ATRL;
    string Trend  ;
    int ATRi ;
    int ATRiL  ; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
 
    
   if(myChartPeriod == 0) { myChartPeriod = Period() ; } 
   if(ATRTimeFrame == 0)  { ATRTimeFrame = Period() ; }       
   tChartPeriod =  TimeFrameToString(myChartPeriod) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
 
   win          = 0 ;
    
 dHead01="rggh01"+ tChartPeriod ;  dHead02="rgg202"+ tChartPeriod ;     
    
 dLabel01="rgg01"+ tChartPeriod ;  dValue01="rggv01"+ tChartPeriod ; 
 dLabel02="rgg02"+ tChartPeriod ;  dValue02="rggv02"+ tChartPeriod ; 
 dLabel03="rgg03"+ tChartPeriod ;  dValue03="rggv03"+ tChartPeriod ; 
 dLabel04="rgg04"+ tChartPeriod ;  dValue04="rggv04"+ tChartPeriod ; 
 dLabel05="rgg05"+ tChartPeriod ;  dValue05="rggv05"+ tChartPeriod ; 
 dLabel06="rgg06"+ tChartPeriod ;  dValue06="rggv06"+ tChartPeriod ; 
 dLabel07="rgg07"+ tChartPeriod ;  dValue07="rggv07"+ tChartPeriod ; 
 dLabel08="rgg08"+ tChartPeriod ;  dValue08="rggv08"+ tChartPeriod ; 
 dLabel09="rgg09"+ tChartPeriod ;  dValue09="rggv09"+ tChartPeriod ; 
 dLabel10="rgg10"+ tChartPeriod ;  dValue10="rggv10"+ tChartPeriod ; 
 dLabel11="rgg11"+ tChartPeriod ;  dValue11="rggv11"+ tChartPeriod ;     
 dLabel12="rgg12"+ tChartPeriod ;  dValue12="rggv12"+ tChartPeriod ;    
 dLabel13="rgg13"+ tChartPeriod ;  dValue13="rggv13"+ tChartPeriod ;     
  
 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

   ObjectsDeleteAll(win);  
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

//----

     Trend = "No Trend";
     ATRi = ATR;
     ATRiL = ATRL; 
     
    brokerhour = Hour();
    brokermin = Minute();
    brokersecond = Seconds();
    
    ATR = iATR(NULL, ATRTimeFrame, ATRShort, 0)/ Point;
    ATRL = iATR(NULL,ATRTimeFrame, ATRLong,0) / Point;

     ATRi = ATR;
     ATRiL = ATRL; 
     
    for(i=1; i<=BarCount; i++)  
      {
         o = iOpen(NULL,PeriodSize,i);
         h = iHigh(NULL,PeriodSize,i);
         l = iLow(NULL,PeriodSize,i);
         c = iClose(NULL,PeriodSize,i);
         //Range = h-l;
                  
         if(o<c)
            {
               Range = c-o;
               temp = up;
               up = temp+Range;
            }
            
         if(o>c)
            {
               Range = o-c;
               temp = down;
               down = temp+Range;
            }
         
      }          

   if ( up > down )
      { 
         ratio = up/down;
         if(ratio>Factor) Trend = "Trend UP";
         else Trend = "NO Trend";
      }
   if ( down > up )
      {
         ratio = -1*down/up;
         if(ratio < -1*Factor) Trend = "Trend DOWN";
         else Trend = "NO Trend";
      }
   Strength = up/Point - down/Point;
   
/*   
   Comment( brokerhour, ":",brokermin,":",brokersecond, "      ", Trend,"    ATR (", ATRTimeFrame,",",ATRShort,", ",ATRLong,") = ", ATRi,",  ", ATRiL,"   Ratio = ", ATR/ATRL,":1\n",
               "Strength = ", Strength, "     Up = ", up/Point, "     Down = ", -1*down/Point,"   Ratio = ", ratio,
               " : 1\nTime Scale = ", PeriodSize, " Minutes", "      Length of Trend = ", BarCount, " Bars back");
*/        


DoShowGauge() ;

   return(0);
  }
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+ 

void DoShowGauge()
{


S01 =  brokerhour + ":" + brokermin + ":" + brokersecond ;
S02 = Trend ;
S03 = "ATR(" +  ATRTimeFrame + "," + ATRShort + "," + ATRLong + ")= " + ATRi+ ", " + ATRiL  ; 
S04 = "Ratio = " + ATR/ATRL + ":1" ;
S05 = "Strength = " + Strength ;
S06 = "Up = " + DoubleToStr(up/Point,0) ;
S07 = "Down = " + DoubleToStr((-1*down)/Point,0) ;
S08 = "Ratio = " + DoubleToStr(ratio,4) ;
S09 = "Time Scale = " + PeriodSize + " Minutes" ;
S10 = "Length of Trend = " +  BarCount + " Bars back" ;



X01  = 0 ;
X02  = 0 ;
X03  = 0 ;
X04  = 0 ;
X05  = 0;
X06  = 0 ;
X07  = 0  ;
X08  = 0 ;
X09  = 0 ;
X10  = 0 ;
X11  = 0;
X12  = 0;
X13  = 0;

string StrH   = " AggregateTrend " ;
string StrX01 = "Open   " ; 
string StrX02 = "High   " ; 
string StrX03 = "Low    " ; 
string StrX04 = "Close  " ;  
string StrX05 = "Range  " ; 
string StrX06 = "Ret%   " ;
string StrX07 = "Wick%  " ;
string StrX08 = "Body%  " ;  
string StrX09 = "Tail%  " ;  
string StrX10 = "Avg("+myBars+")" ;  
string StrX11 = "Cl-Open" ;  
string StrX12 = "Hi-Open" ;  
string StrX13 = "Open-Lo" ;  
  
color color_X01=myColor1;
color color_X02=myColor2;
color color_X03=myColor3;  
color color_X04=myColor4;
color color_X05=myColor5;
color color_X06=myColor6;
color color_X07=myColor7;  
color color_X08=myColor8;  
color color_X09=myColor9;   
color color_X10=myColor10; 
color color_X11=myColor11; 
color color_X12=myColor12; 
color color_X13=myColor13; 

     	
//---- Set Pivots labels

   int WindowToUse;
   int Corner_line, Xdist_line;
   int Corner_vSRFP, Xdist_text, Xdist_vSRFP;
   int Ydist_line5;
   int Corner_pivots, Xdist_pivots, Ydist_pivots;
   int Ydist_X01, Ydist_X02, Ydist_X03, Ydist_X04, Ydist_X05, Ydist_X06, Ydist_X07, Ydist_X08, Ydist_X09, Ydist_X10 ;
   int YdistInc, Ydist_X11, Ydist_X12, Ydist_X13 ;
   
    WindowToUse =  0;
    Corner_line = 1;
    Corner_vSRFP = 1;
    Xdist_line = 21; Xdist_text = 21; Xdist_vSRFP = 23;
    Corner_pivots = 1; Xdist_pivots = 21; 
    
    Ydist_pivots = myChartY;  
    Ydist_line5 = Ydist_pivots + 11; YdistInc = 15 ;
    
    Ydist_X01 = Ydist_pivots + 25; 
    Ydist_X02 = Ydist_X01 + YdistInc; 
    Ydist_X03 = Ydist_X01 + YdistInc*2; 
    Ydist_X04 = Ydist_X01 + YdistInc*3; 
    Ydist_X05 = Ydist_X01 + YdistInc*4;
    Ydist_X06 = Ydist_X01 + YdistInc*5;    
    Ydist_X07 = Ydist_X01 + YdistInc*6;
    Ydist_X08 = Ydist_X01 + YdistInc*7;    
    Ydist_X09 = Ydist_X01 + YdistInc*8;    
    Ydist_X10 = Ydist_X01 + YdistInc*9;    
    Ydist_X11 = Ydist_X01 + YdistInc*10;      
    Ydist_X12 = Ydist_X01 + YdistInc*11;      
    Ydist_X13 = Ydist_X01 + YdistInc*12;      

//+------------------------------------------------------------------+ 
   ObjectCreate(dHead01, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dHead01,tChartPeriod + StrH,myFontSize, myFont, myColorH);
   ObjectSet(dHead01, OBJPROP_CORNER, myCorner);
   ObjectSet(dHead01, OBJPROP_XDISTANCE, Xdist_pivots);
   ObjectSet(dHead01, OBJPROP_YDISTANCE, Ydist_pivots);
   
   ObjectCreate(dHead02, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dHead02,"------------------",myFontSize, myFont, myColorH);
   ObjectSet(dHead02, OBJPROP_CORNER, myCorner);
   ObjectSet(dHead02, OBJPROP_XDISTANCE, Xdist_line);
   ObjectSet(dHead02, OBJPROP_YDISTANCE, Ydist_line5);

//+------------------------------------------------------------------+    
   ObjectCreate(dLabel01, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel01,S01,myFontSize, myFont, myColor1 );
   ObjectSet(dLabel01, OBJPROP_CORNER, myCorner);
   ObjectSet(dLabel01, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel01, OBJPROP_YDISTANCE, Ydist_X01);
   
   ObjectCreate(dLabel02, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel02,S02,myFontSize, myFont, myColor2 );
   ObjectSet(dLabel02, OBJPROP_CORNER, myCorner);
   ObjectSet(dLabel02, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel02, OBJPROP_YDISTANCE, Ydist_X02);

   ObjectCreate(dLabel03, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel03,S03,myFontSize, myFont, myColor3 );
   ObjectSet(dLabel03, OBJPROP_CORNER, myCorner);
   ObjectSet(dLabel03, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel03, OBJPROP_YDISTANCE, Ydist_X03);

   ObjectCreate(dLabel04, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel04,S04,myFontSize, myFont, myColor4 );
   ObjectSet(dLabel04, OBJPROP_CORNER, myCorner);
   ObjectSet(dLabel04, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel04, OBJPROP_YDISTANCE, Ydist_X04);

   ObjectCreate(dLabel05, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel05,S05,myFontSize, myFont, myColor5 );
   ObjectSet(dLabel05, OBJPROP_CORNER, myCorner);
   ObjectSet(dLabel05, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel05, OBJPROP_YDISTANCE, Ydist_X05);

   ObjectCreate(dLabel06, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel06,S06,myFontSize, myFont, myColor6 );
   ObjectSet(dLabel06, OBJPROP_CORNER, myCorner);
   ObjectSet(dLabel06, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel06, OBJPROP_YDISTANCE, Ydist_X06);

   ObjectCreate(dLabel07, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel07,S07,myFontSize, myFont, myColor7 );
   ObjectSet(dLabel07, OBJPROP_CORNER, myCorner);
   ObjectSet(dLabel07, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel07, OBJPROP_YDISTANCE, Ydist_X07);
   
   ObjectCreate(dLabel08, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel08,S08,myFontSize, myFont, myColor8 );
   ObjectSet(dLabel08, OBJPROP_CORNER, myCorner);
   ObjectSet(dLabel08, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel08, OBJPROP_YDISTANCE, Ydist_X08);   

   ObjectCreate(dLabel09, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel09,S09,myFontSize, myFont, myColor9 );
   ObjectSet(dLabel09, OBJPROP_CORNER, myCorner);
   ObjectSet(dLabel09, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel09, OBJPROP_YDISTANCE, Ydist_X09);

   ObjectCreate(dLabel10, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel10,S10,myFontSize, myFont, myColor10 );
   ObjectSet(dLabel10, OBJPROP_CORNER, myCorner);
   ObjectSet(dLabel10, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel10, OBJPROP_YDISTANCE, Ydist_X10);
   
   
}

//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

