//+------------------------------------------------------------------+ 
//|   tro_pivot_position                                             | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window


//---- input parameters 


extern int myChartY = 0 ;

extern int myChartPeriod = 0 ;
extern int myBars        = 24 ;

extern string myFont  = "Courier" ; // "Verdana" Courier
extern int myFontSize = 12 ; //9
 
extern color myColorH = Orange ;
extern color myColor1 = DodgerBlue ;
extern color myColor2 = DodgerBlue ;
extern color myColor3 = DodgerBlue ;
extern color myColor4 = DodgerBlue ;
extern color myColor5 = DodgerBlue ;
extern color myColor6 = DodgerBlue ;
extern color myColor7 = PaleVioletRed ;
extern color myColor8 = LightSalmon ;
extern color myColor9 = LightSalmon ;
extern color myColor10 = LightSalmon ;
extern color myColor11 = LightSalmon ;
extern color myColor12 = LightSalmon ;
extern color myColor13 = LightSalmon ;
extern color myColor14 = DarkKhaki ;
extern color myColor15 = DarkKhaki ;
extern color myColor16 = DarkKhaki ;
extern color myColor17 = DarkKhaki ;
extern color myColor18 = Yellow ;
extern color myColor19 = Yellow ;
//---- buffers
 

int i;
   

double X01,X02,X03,X04,X05 ;
double X06 ;   
double X07 ;
double X08, X09, X10,X11,X12, X13,X14,X15,X16, X17,X18, X19 ; 
double xRet, xRetBody, xRetWick, xRetTail ;
double xRetPct, xRetBodyPct, xRetWickPct, xRetTailPct;    
  
string symbol, tChartPeriod ;  
int    digits, period, win ; 
int    Long_Score, Short_Score ;


double point,  close  ;  

double day_high=0;
double day_low=0;
double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double today_open=0;
double today_high=0;
double today_low=0;
double P=0;
double Q=0;
double R1,R2,R3;
double M0,M1,M2,M3,M4,M5;
double S1,S2,S3;
double H4,H3,L4,L3;
double nQ=0;
double nD=0;
double D=0;
double rates_d1[2][6];

double R4,R5,R6;
double S4,S5,S6;
double N0,N1,N2,N3,N4,N5;
 

string dHead01, dHead02;
string dLabel01, dValue01;
string dLabel02, dValue02;
string dLabel03, dValue03;
string dLabel04, dValue04;
string dLabel05, dValue05;
string dLabel06, dValue06;
string dLabel07, dValue07;
string dLabel08, dValue08;
string dLabel09, dValue09;
string dLabel10, dValue10;
string dLabel11, dValue11;
string dLabel12, dValue12;
string dLabel13, dValue13;
string dLabel14, dValue14;
string dLabel15, dValue15;
string dLabel16, dValue16;
string dLabel17, dValue17;
string dLabel18, dValue18;
string dLabel19, dValue19;

//+------------------------------------------------------------------+
  
int init()
  {

   if(myChartPeriod == 0) { myChartPeriod = Period() ; }    
   tChartPeriod =  TimeFrameToString(myChartPeriod) ;
   symbol       =  Symbol() ;
   digits       =  0 ;
   point        =  Point ;
 
   win          = 0 ;
    
 dHead01="pvth01"+ tChartPeriod ;  dHead02="pvt202"+ tChartPeriod ;     
    
 dLabel01="pvt01"+ tChartPeriod ;  dValue01="pvtv01"+ tChartPeriod ; 
 dLabel02="pvt02"+ tChartPeriod ;  dValue02="pvtv02"+ tChartPeriod ; 
 dLabel03="pvt03"+ tChartPeriod ;  dValue03="pvtv03"+ tChartPeriod ; 
 dLabel04="pvt04"+ tChartPeriod ;  dValue04="pvtv04"+ tChartPeriod ; 
 dLabel05="pvt05"+ tChartPeriod ;  dValue05="pvtv05"+ tChartPeriod ; 
 dLabel06="pvt06"+ tChartPeriod ;  dValue06="pvtv06"+ tChartPeriod ; 
 dLabel07="pvt07"+ tChartPeriod ;  dValue07="pvtv07"+ tChartPeriod ; 
 dLabel08="pvt08"+ tChartPeriod ;  dValue08="pvtv08"+ tChartPeriod ; 
 dLabel09="pvt09"+ tChartPeriod ;  dValue09="pvtv09"+ tChartPeriod ; 
 dLabel10="pvt10"+ tChartPeriod ;  dValue10="pvtv10"+ tChartPeriod ; 
 dLabel11="pvt11"+ tChartPeriod ;  dValue11="pvtv11"+ tChartPeriod ;     
 dLabel12="pvt12"+ tChartPeriod ;  dValue12="pvtv12"+ tChartPeriod ;    
 dLabel13="pvt13"+ tChartPeriod ;  dValue13="pvtv13"+ tChartPeriod ; 
 dLabel14="pvt14"+ tChartPeriod ;  dValue14="pvtv14"+ tChartPeriod ; 
 dLabel15="pvt15"+ tChartPeriod ;  dValue15="pvtv15"+ tChartPeriod ;     
 dLabel16="pvt16"+ tChartPeriod ;  dValue16="pvtv16"+ tChartPeriod ;    
 dLabel17="pvt17"+ tChartPeriod ;  dValue17="pvtv17"+ tChartPeriod ;       
 dLabel18="pvt18"+ tChartPeriod ;  dValue18="pvtv18"+ tChartPeriod ;    
 dLabel19="pvt19"+ tChartPeriod ;  dValue19="pvtv19"+ tChartPeriod ;  
      
 R1=0; R2=0; R3=0;
 M0=0; M1=0; M2=0; M3=0; M4=0; M5=0;
 S1=0; S2=0; S3=0;
 H4=0; H3=0; L4=0; L3=0;

 R4=0; R5=0; R6=0;
 S4=0; S5=0; S6=0;
 N0=0; N1=0; N2=0; N3=0; N4=0; N5=0; 

      
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
  {
ObjectsDeleteAll( win );
    
   return(0);
  }


//+------------------------------------------------------------------+

int start()
{
  
DoShowGauge() ;

return(0); 
} 

//+------------------------------------------------------------------+ 

void DoShowGauge()
{



//---- exit if period is greater than daily charts
if(Period() > 1440)
{
Print("Error - Chart period is greater than 1 day.");
return(-1); // then exit
}

//---- Get new daily prices

ArrayCopyRates(rates_d1, Symbol(), PERIOD_D1);

yesterday_close = rates_d1[1][4];
yesterday_open = rates_d1[1][1];
today_open = rates_d1[0][1];
yesterday_high = rates_d1[1][3];
yesterday_low = rates_d1[1][2];
day_high = rates_d1[0][3];
day_low = rates_d1[0][2];


//---- Calculate Pivots

D = (day_high - day_low);
Q = (yesterday_high - yesterday_low);
P = (yesterday_high + yesterday_low + yesterday_close) / 3;
R1 = (2*P)-yesterday_low;
S1 = (2*P)-yesterday_high;
R2 = P+(yesterday_high - yesterday_low);
S2 = P-(yesterday_high - yesterday_low);

	H4 = (Q*0.55)+yesterday_close;
	H3 = (Q*0.27)+yesterday_close;
	R3 = (2*P)+(yesterday_high-(2*yesterday_low));
	M5 = (R2+R3)/2;
//	R2 = P-S1+R1;
	M4 = (R1+R2)/2;
//	R1 = (2*P)-yesterday_low;
	M3 = (P+R1)/2;
//	P = (yesterday_high + yesterday_low + yesterday_close)/3;
	M2 = (P+S1)/2;
//	S1 = (2*P)-yesterday_high;
	M1 = (S1+S2)/2;
//	S2 = P-R1+S1;
	S3 = (2*P)-((2* yesterday_high)-yesterday_low);
	L3 = yesterday_close-(Q*0.27);	
	L4 = yesterday_close-(Q*0.55);	
	M0 = (S2+S3)/2;

	R4 = (3*P)+(yesterday_high-(3*yesterday_low));
	S4 = (3*P)-((3* yesterday_high)-yesterday_low);
	R5 = (4*P)+(yesterday_high-(4*yesterday_low));
	S5 = (4*P)-((4* yesterday_high)-yesterday_low);
	R6 = (5*P)+(yesterday_high-(5*yesterday_low));
	S6 = (5*P)-((5* yesterday_high)-yesterday_low);

	N0 = (S4+S3)/2;
	N1 = (S4+S5)/2;
	N2 = (S6+S5)/2;
	N3 = (R4+R3)/2;	
	N4 = (R4+R5)/2;
	N5 = (R6+R5)/2;
							
//---- 


if (Q > 5) 
{
	nQ = Q;
}
else
{
	nQ = Q*10000;
}

if (D > 5)
{
	nD = D;
}
else
{
	nD = D*10000;
}

 
   
close     = Close[0] ;  
  
 

 
 
X01  = ( close - R6 ) / point ;
X02  = ( close - R5 ) / point ;
X03  = ( close - R4 ) / point ;
X04  = ( close - R3 ) / point ;
X05  = ( close - R2 ) / point ; 
X06  = ( close - R1) / point ; 
X07  = ( close - P ) / point ;
X08  = ( close - S1 ) / point ;
X09  = ( close - S2 ) / point ;
X10  = ( close - S3) / point ;
X11  = ( close - S4 ) / point ;
X12  = ( close - S5 ) / point ;
X13  = ( close - S6 ) / point ;
/*
X14  = ( close - W1_Open ) / point ;
X15  = ( close - W1_High1 ) / point ;
X16  = ( close - W1_Low1 ) / point ;
X17  = ( close - W1_Mid1 ) / point ;
*/

//Comment( "PP= ", DoubleToStr(( D1_Close1 + D1_Open + D1_Low1) / 3 , 4) );


string StrH   = "Pivot Position" ;
string StrX01 = "R6       " ; 
string StrX02 = "R5       " ; 
string StrX03 = "R4       " ; 
string StrX04 = "R3       " ;  
string StrX05 = "R2       " ;  
string StrX06 = "R1       " ;
string StrX07 = "PP       " ;
string StrX08 = "S1       " ;  
string StrX09 = "S2       " ;
string StrX10 = "S3       " ; 
string StrX11 = "S4       " ; 
string StrX12 = "S5       " ; 
string StrX13 = "S6       " ;
/*
string StrX14 = "S" ; 
string StrX15 = "PrvW High" ; 
string StrX16 = "PrvW Low " ; 
string StrX17 = "PrvW Mid " ;

string StrX18 = "Long Risk" ; 
string StrX19 = "Shrt Risk" ; 
 */
  
color color_X01=myColor1;
color color_X02=myColor2;
color color_X03=myColor3;  
color color_X04=myColor4;
color color_X05=myColor5;
color color_X06=myColor6;
color color_X07=myColor7;  
color color_X08=myColor8;  
color color_X09=myColor9;   
color color_X10=myColor10; 
color color_X11=myColor11; 
color color_X12=myColor12; 
color color_X13=myColor13; 
color color_X14=myColor14; 
color color_X15=myColor15; 
color color_X16=myColor16; 
color color_X17=myColor17; 
color color_X18=myColor18; 
color color_X19=myColor19; 



Long_Score  = 0 ; 
Short_Score = 0 ;  

// 1 = "CurD Open"  
if( X01 > 0 ) { color_X01 = Lime ; Short_Score  = Short_Score + 1 ; } else { color_X01 = Red ; Long_Score  = Long_Score + 1 ;  } 

// 2 = "PrvD High" 
if( X02 > 0 ) { color_X02 = Lime ;  Long_Score  = Long_Score + 1 ; } else { color_X02 = Red ; } 

// 3 = "PrvD Low "  
if( X03 > 0 ) { color_X03 = Lime ; } else { color_X03 = Red ; Short_Score  = Short_Score + 1 ; } 

// 4 = "PivotD   "   
if( X04 > 0 ) { color_X04 = Lime ; Short_Score  = Short_Score + 1 ; } else { color_X04 = Red ; Long_Score  = Long_Score + 1 ;  } 

// 5 = "PrvD Mid " 
if( X05 > 0 ) { color_X05 = Lime ; Short_Score  = Short_Score + 1 ; } else { color_X05 = Red ; Long_Score  = Long_Score + 1 ; } 

// 6 = "CurrD Mid" 
if( X06 > 0 ) { color_X06 = Lime ; Short_Score  = Short_Score + 1 ; } else { color_X06 = Red ; Long_Score  = Long_Score + 1 ; }

// 7 = tChartPeriod + " jjrvat"
if( X07 > 0 ) { color_X07 = Lime ; Short_Score  = Short_Score + 1 ;  } else { color_X07 = Red ; Long_Score  = Long_Score + 1 ;  }    

// 8 = tChartPeriod + " EMA(5)"
if( X08 > 0 ) { color_X08 = Lime ; Short_Score  = Short_Score + 1 ; } else { color_X08 = Red ; Long_Score  = Long_Score + 1 ; } 

// 9 = "H1 Tunnel" 
if( X09 > 0 ) { color_X09 = Lime ; Short_Score  = Short_Score + 1 ; } else { color_X09 = Red ; Long_Score  = Long_Score + 1 ;  }

// 10 = "CurH Open" 
if( X10 > 0 ) { color_X10 = Lime ;   Short_Score  = Short_Score + 1 ; } else { color_X10 = Red ;  Long_Score  = Long_Score + 1 ;}  	

// 11 = "PrvH High"  
if( X11 > 0 ) { color_X11 = Lime ; Long_Score  = Long_Score + 1 ; } else { color_X11 = Red ; }  

// 12 = "PrvH Low "
if( X12 > 0 ) { color_X12 = Lime ; } else { color_X12 = Red ;  Short_Score  = Short_Score + 1 ;  }  

// 13 = "PrvH Mid " 
if( X13 > 0 ) { color_X13 = Lime ; Short_Score  = Short_Score + 1 ; } else { color_X13 = Red ; Long_Score  = Long_Score + 1 ;  }       	

// 14 = "CurW Open"
if( X14 > 0 ) { color_X14 = Lime ;  Short_Score  = Short_Score + 1 ; } else { color_X14 = Red ;  Long_Score  = Long_Score + 1 ; }  	

// 15 = "PrvW High" 
if( X15 > 0 ) { color_X15 = Lime ;  Long_Score  = Long_Score + 1 ; } else { color_X15 = Red ; }  

// 16 = "PrvW Low "  
if( X16 > 0 ) { color_X16 = Lime ; } else { color_X16 = Red ; Short_Score  = Short_Score + 1 ; }  

// 17 = "PrvW Mid " 
if( X17 > 0 ) { color_X17 = Lime ; Short_Score  = Short_Score + 1 ; } else { color_X17 = Red ; Long_Score  = Long_Score + 1 ; }       	

X18  = Long_Score ;
X19  = Short_Score ;  
     	
// 18 = "Long Risk" 
// 19 = "Shrt Risk"   
if( X18 > X19 ) { color_X18 = Lime ;  color_X19 = Red ; } else { color_X19 = Lime ;  color_X18 = Red ; }      	
  
    	


     	
       	
//---- Set Pivots labels

   int WindowToUse;
   int Corner_line, Xdist_line;
   int Corner_text, Corner_vSRFP, Xdist_text, Xdist_vSRFP;
   int Ydist_line5;
   int Corner_pivots, Xdist_pivots, Ydist_pivots;
   int Ydist_X01, Ydist_X02, Ydist_X03, Ydist_X04, Ydist_X05, Ydist_X06, Ydist_X07, Ydist_X08, Ydist_X09, Ydist_X10 ;
   int Ydist_X11, Ydist_X12, Ydist_X13,Ydist_X14, Ydist_X15, Ydist_X16, Ydist_X17, Ydist_X18, Ydist_X19  ;  
   int YdistInc ;
   
    WindowToUse =  0;
    Corner_line = 1;
    Corner_text = 1; Corner_vSRFP = 1;
    Xdist_line = 21; Xdist_text = 63; Xdist_vSRFP = 23;
    Corner_pivots = 1; Xdist_pivots = 21; 
    
    Ydist_pivots = myChartY;  
    Ydist_line5 = Ydist_pivots + 11; YdistInc = 15 ;
    
    Ydist_X01 = Ydist_pivots + 25; 
    Ydist_X02 = Ydist_X01 + YdistInc; 
    Ydist_X03 = Ydist_X01 + YdistInc*2; 
    Ydist_X04 = Ydist_X01 + YdistInc*3; 
    Ydist_X05 = Ydist_X01 + YdistInc*4;
    Ydist_X06 = Ydist_X01 + YdistInc*5;    
    Ydist_X07 = Ydist_X01 + YdistInc*6;
    Ydist_X08 = Ydist_X01 + YdistInc*7;    
    Ydist_X09 = Ydist_X01 + YdistInc*8;    
    Ydist_X10 = Ydist_X01 + YdistInc*9;    
    Ydist_X11 = Ydist_X01 + YdistInc*10; 
    Ydist_X12 = Ydist_X01 + YdistInc*11;     
    Ydist_X13 = Ydist_X01 + YdistInc*12;     
    Ydist_X14 = Ydist_X01 + YdistInc*13; 
    Ydist_X15 = Ydist_X01 + YdistInc*14;     
    Ydist_X16 = Ydist_X01 + YdistInc*15;  
    Ydist_X17 = Ydist_X01 + YdistInc*16;     
    Ydist_X18 = Ydist_X01 + YdistInc*17;  
    Ydist_X19 = Ydist_X01 + YdistInc*18;
        
//+------------------------------------------------------------------+ 
   ObjectCreate(dHead01, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dHead01,StrH,myFontSize, myFont, myColorH);
   ObjectSet(dHead01, OBJPROP_CORNER, Corner_pivots);
   ObjectSet(dHead01, OBJPROP_XDISTANCE, Xdist_pivots);
   ObjectSet(dHead01, OBJPROP_YDISTANCE, Ydist_pivots);
   
   ObjectCreate(dHead02, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dHead02,"--------------",myFontSize, myFont, myColorH);
   ObjectSet(dHead02, OBJPROP_CORNER, Corner_line);
   ObjectSet(dHead02, OBJPROP_XDISTANCE, Xdist_line);
   ObjectSet(dHead02, OBJPROP_YDISTANCE, Ydist_line5);

//+------------------------------------------------------------------+    
   ObjectCreate(dLabel01, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel01,StrX01,myFontSize, myFont, myColor1 );
   ObjectSet(dLabel01, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel01, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel01, OBJPROP_YDISTANCE, Ydist_X01);
   
   ObjectCreate(dValue01, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue01," "+DoubleToStr(X01,digits),myFontSize, myFont, color_X01);
   ObjectSet(dValue01, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue01, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue01, OBJPROP_YDISTANCE, Ydist_X01);

//+------------------------------------------------------------------+     
   ObjectCreate(dLabel02, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel02,StrX02,myFontSize, myFont, myColor2 );
   ObjectSet(dLabel02, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel02, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel02, OBJPROP_YDISTANCE, Ydist_X02);
   
   ObjectCreate(dValue02, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue02," "+DoubleToStr(X02,digits),myFontSize, myFont, color_X02);
   ObjectSet(dValue02, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue02, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue02, OBJPROP_YDISTANCE, Ydist_X02);

//+------------------------------------------------------------------+ 
   ObjectCreate(dLabel03, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel03,StrX03,myFontSize, myFont, myColor3 );
   ObjectSet(dLabel03, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel03, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel03, OBJPROP_YDISTANCE, Ydist_X03);
   
   ObjectCreate(dValue03, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue03," "+DoubleToStr(X03,digits),myFontSize, myFont, color_X03);
   ObjectSet(dValue03, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue03, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue03, OBJPROP_YDISTANCE, Ydist_X03);

//+------------------------------------------------------------------+ 
   ObjectCreate(dLabel04, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel04,StrX04,myFontSize, myFont, myColor4 );
   ObjectSet(dLabel04, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel04, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel04, OBJPROP_YDISTANCE, Ydist_X04);
   
   ObjectCreate(dValue04, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue04," "+DoubleToStr(X04,digits),myFontSize, myFont, color_X04);
   ObjectSet(dValue04, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue04, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue04, OBJPROP_YDISTANCE, Ydist_X04);  

//+------------------------------------------------------------------+    
   ObjectCreate(dLabel05, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel05,StrX05,myFontSize, myFont, myColor5 );
   ObjectSet(dLabel05, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel05, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel05, OBJPROP_YDISTANCE, Ydist_X05);
   
   ObjectCreate(dValue05, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue05," "+DoubleToStr(X05,digits),myFontSize, myFont, color_X05);
   ObjectSet(dValue05, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue05, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue05, OBJPROP_YDISTANCE, Ydist_X05);

//+------------------------------------------------------------------+     
   ObjectCreate(dLabel06, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel06,StrX06,myFontSize, myFont, myColor6 );
   ObjectSet(dLabel06, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel06, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel06, OBJPROP_YDISTANCE, Ydist_X06);
   
   ObjectCreate(dValue06, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue06," "+DoubleToStr(X06,digits),myFontSize, myFont, color_X06);
   ObjectSet(dValue06, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue06, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue06, OBJPROP_YDISTANCE, Ydist_X06);

   ObjectCreate(dLabel07, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel07,StrX07,myFontSize, myFont, myColor7 );
   ObjectSet(dLabel07, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel07, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel07, OBJPROP_YDISTANCE, Ydist_X07);
   
   ObjectCreate(dValue07, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue07," "+DoubleToStr(X07,digits),myFontSize, myFont, color_X07);
   ObjectSet(dValue07, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue07, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue07, OBJPROP_YDISTANCE, Ydist_X07);

   ObjectCreate(dLabel08, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel08,StrX08,myFontSize, myFont, myColor8 );
   ObjectSet(dLabel08, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel08, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel08, OBJPROP_YDISTANCE, Ydist_X08);
   
   ObjectCreate(dValue08, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue08," "+DoubleToStr(X08,digits),myFontSize, myFont, color_X08);
   ObjectSet(dValue08, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue08, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue08, OBJPROP_YDISTANCE, Ydist_X08);  
  
   ObjectCreate(dLabel09, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel09,StrX09,myFontSize, myFont, myColor9 );
   ObjectSet(dLabel09, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel09, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel09, OBJPROP_YDISTANCE, Ydist_X09);
   
   ObjectCreate(dValue09, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue09," "+DoubleToStr(X09,digits),myFontSize, myFont, color_X09);
   ObjectSet(dValue09, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue09, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue09, OBJPROP_YDISTANCE, Ydist_X09);  
   
   
   ObjectCreate(dLabel10, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel10,StrX10,myFontSize, myFont, myColor10 );
   ObjectSet(dLabel10, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel10, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel10, OBJPROP_YDISTANCE, Ydist_X10);
   
   ObjectCreate(dValue10, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue10," "+DoubleToStr(X10,digits),myFontSize, myFont, color_X10);
   ObjectSet(dValue10, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue10, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue10, OBJPROP_YDISTANCE, Ydist_X10);  
 
   ObjectCreate(dLabel11, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel11,StrX11,myFontSize, myFont, myColor11 );
   ObjectSet(dLabel11, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel11, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel11, OBJPROP_YDISTANCE, Ydist_X11);
   
   ObjectCreate(dValue11, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue11," "+DoubleToStr(X11,digits),myFontSize, myFont, color_X11);
   ObjectSet(dValue11, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue11, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue11, OBJPROP_YDISTANCE, Ydist_X11);     
   
   ObjectCreate(dLabel12, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel12,StrX12,myFontSize, myFont, myColor12 );
   ObjectSet(dLabel12, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel12, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel12, OBJPROP_YDISTANCE, Ydist_X12);
   
   ObjectCreate(dValue12, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue12," "+DoubleToStr(X12,digits),myFontSize, myFont, color_X12);
   ObjectSet(dValue12, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue12, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue12, OBJPROP_YDISTANCE, Ydist_X12);     


   ObjectCreate(dLabel13, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel13,StrX13,myFontSize, myFont, myColor13 );
   ObjectSet(dLabel13, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel13, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel13, OBJPROP_YDISTANCE, Ydist_X13);
   
   ObjectCreate(dValue13, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue13," "+DoubleToStr(X13,digits),myFontSize, myFont, color_X13);
   ObjectSet(dValue13, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue13, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue13, OBJPROP_YDISTANCE, Ydist_X13);  
/*
   ObjectCreate(dLabel14, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel14,StrX14,myFontSize, myFont, myColor14 );
   ObjectSet(dLabel14, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel14, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel14, OBJPROP_YDISTANCE, Ydist_X14);
   
   ObjectCreate(dValue14, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue14," "+DoubleToStr(X14,digits),myFontSize, myFont, color_X14);
   ObjectSet(dValue14, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue14, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue14, OBJPROP_YDISTANCE, Ydist_X14);  
 

   ObjectCreate(dLabel15, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel15,StrX15,myFontSize, myFont, myColor15 );
   ObjectSet(dLabel15, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel15, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel15, OBJPROP_YDISTANCE, Ydist_X15);
   
   ObjectCreate(dValue15, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue15," "+DoubleToStr(X15,digits),myFontSize, myFont, color_X15);
   ObjectSet(dValue15, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue15, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue15, OBJPROP_YDISTANCE, Ydist_X15);  


   ObjectCreate(dLabel16, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel16,StrX16,myFontSize, myFont, myColor16 );
   ObjectSet(dLabel16, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel16, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel16, OBJPROP_YDISTANCE, Ydist_X16);
   
   ObjectCreate(dValue16, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue16," "+DoubleToStr(X16,digits),myFontSize, myFont, color_X16);
   ObjectSet(dValue16, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue16, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue16, OBJPROP_YDISTANCE, Ydist_X16);  


   ObjectCreate(dLabel17, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel17,StrX17,myFontSize, myFont, myColor17 );
   ObjectSet(dLabel17, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel17, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel17, OBJPROP_YDISTANCE, Ydist_X17);
   
   ObjectCreate(dValue17, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue17," "+DoubleToStr(X17,digits),myFontSize, myFont, color_X17);
   ObjectSet(dValue17, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue17, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue17, OBJPROP_YDISTANCE, Ydist_X17);  


   ObjectCreate(dLabel18, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel18,StrX18,myFontSize, myFont, myColor18 );
   ObjectSet(dLabel18, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel18, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel18, OBJPROP_YDISTANCE, Ydist_X18);
   
   ObjectCreate(dValue18, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue18," "+DoubleToStr(X18,digits),myFontSize, myFont, color_X18);
   ObjectSet(dValue18, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue18, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue18, OBJPROP_YDISTANCE, Ydist_X18);  


   ObjectCreate(dLabel19, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dLabel19,StrX19,myFontSize, myFont, myColor19 );
   ObjectSet(dLabel19, OBJPROP_CORNER, Corner_text);
   ObjectSet(dLabel19, OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet(dLabel19, OBJPROP_YDISTANCE, Ydist_X19);
   
   ObjectCreate(dValue19, OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText(dValue19," "+DoubleToStr(X19,digits),myFontSize, myFont, color_X19);
   ObjectSet(dValue19, OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet(dValue19, OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet(dValue19, OBJPROP_YDISTANCE, Ydist_X19);   
*/

 
}

//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

/*


TRO RANGE GAUGE displays range information.


Open is candle's D1_Open price.  Green if above previous candle's D1_Open price, red if beD1_Low1.

High is candle's D1_High1 price.  Green if above previous candle's D1_High1 price, red if beD1_Low1.

Low is candle's D1_Low1 price.  Green if above previous candle's D1_Low1 price, red if beD1_Low1.

Close is candle's D1_Close1 price.  Green if above previous candle's D1_Close1 price, red if beD1_Low1.

Range is today's range.  Green if above yesterday's range, red if bD1_Low1.

Ret% is retrace percentage off today's D1_Low1.

Wick% is the wick (D1_High1 - candle top) percentage of the range.

Body% is the candle body (candle top - candle bottom) percentage of the range.

Tail% is the tail (candle bottom - D1_Low1) percentage of the range.

Avg(x) is the average range over the last X bars.  Green is above today's range, red if beD1_Low1.

*/