//+------------------------------------------------------------------+
//|       tro_trendcount_open                                        |
//|                                                                  |
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND CONTRIBUTIONS ACCEPTED                               | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 
#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  DimGray
 

#property indicator_width1 3
 



//---- indicator parameters
 

 


//---- indicator buffers
double     ind_buffer0[];
double     xTrend[];
double     xCount;
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- drawing settings

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexDrawBegin(0,ind_buffer0); 
   SetIndexBuffer(0,ind_buffer0) ;
       
   return(0);
  }

//+------------------------------------------------------------------+  
int deinit()
  {

   return(0);
  }  
  
//+------------------------------------------------------------------+

int start()
  {
  
   
   int limit;
   int counted_bars=IndicatorCounted();
   
//---- check for possible errors

   if(counted_bars<0) return(-1);
   
//---- last counted bar will be recounted

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for(int i=limit; i >= 0; i--) {  ind_buffer0[i] = 0 ; } // initialize buffer to 0

     
   for( i=limit; i >= 0; i--)
   {
   
      if(Open[i] > Open[i+1]) { ind_buffer0[i] =  ind_buffer0[i+1] + 1 ; } else {
      if(Open[i] < Open[i+1]) { ind_buffer0[i] =  ind_buffer0[i+1] - 1 ; } else { ind_buffer0[i] = 0 ; } }
        
   }   
   
   
return(0);
}

