//+------------------------------------------------------------------+ 
//|                TRO_StartDay                                      | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window
 
extern int BarsToCount = 1440 ;
 
extern color HourColor = Yellow ;
 
double val1,val2;

int deinit()
  {
      ObjectsDeleteAll( );
   return(0);
  }
//----------------------------------------------------------------------------------------
int start()
   {
   
   int counted_bars=IndicatorCounted();
   int bars_count=BarsToCount,i,h,m;
   
   bool drawvl;
       
   
      int   yy = TimeYear(Time[0]);
      int   mm = TimeMonth(Time[0]);
      int   dd = TimeDay(Time[0]);
     datetime var1;
     
         string yymmddms = yy+"."+mm+"."+dd+" 00:00" ;
         
  var1=StrToTime(yymmddms);
  
    
  int      shift=iBarShift(NULL,0,var1,false);   
   
		
   int hh = Highest(NULL,0,MODE_HIGH,shift,0);
   int ll = Lowest(NULL,0,MODE_LOW,shift,0); 
      
   double xRES = iHigh(NULL,0,hh) ;  
   double xSUP = iLow(NULL,0,ll) ;     
      
   for (i=0;i<bars_count;i++)
      {
      ObjectDelete("MMt"+DoubleToStr(i,0));
      ObjectDelete("MMl"+DoubleToStr(i,0));
      }
      
   for (i=0;i<bars_count;i++)
      {
         drawvl=false;
         h=TimeHour(Time[i]);
         m=TimeMinute(Time[i]);

         if (m==0 && h==0) {drawvl=true;VerticalLine("H"+h,i,STYLE_SOLID,HourColor);}

      }

           {drawvl=true;VerticalLine("HH"+hh,hh,STYLE_SOLID,HourColor);}
           {drawvl=true;VerticalLine("LL"+ll,ll,STYLE_SOLID,HourColor);} 
      
      
 Comment( "yymmddms=" , yymmddms, " shift=", shift, "\n",
            " hh=", hh, "\n", 
            " ll=", ll, "\n",   
            " xRES=", xRES, "\n", 
            " xSUP=", xSUP, "\n",            
            "" ) ;
 
   return(0);
   }
   
//----------------------------------------------------------------------------------------------

int VerticalLine(string s,int i,int st,int Col)    //s=Text Label, i = bar, st=Line Style, Col = color
   {
   
   val1=Low[Lowest(NULL,0,MODE_LOW,24,0)];
   val2=High[Highest(NULL,0,MODE_HIGH,24,0)];
      
   ObjectDelete("MMl"+DoubleToStr(i,0));
   
   ObjectCreate("MMl"+DoubleToStr(i,0),OBJ_TREND,0,Time[i],0,Time[i],900);
   ObjectSet("MMl"+DoubleToStr(i,0),OBJPROP_COLOR,Col);
   ObjectSet("MMl"+DoubleToStr(i,0),OBJPROP_WIDTH,1);
   ObjectSet("MMl"+DoubleToStr(i,0),OBJPROP_STYLE,st);
   ObjectSet("MMl"+DoubleToStr(i,0),OBJPROP_RAY,0);
   
   
   ObjectDelete("MMt"+DoubleToStr(i,0));
   
   ObjectCreate("MMt"+DoubleToStr(i,0),OBJ_TEXT,0,Time[i],val2+Point*1);
   ObjectSetText("MMt"+DoubleToStr(i,0),s,8,"Arial",Col);
   ObjectSet("MMt"+DoubleToStr(i,0), OBJPROP_ANGLE, 90);          //Rotates text 90 degrees
   
   ObjectsRedraw();
   
   return(0);
   }


