//+------------------------------------------------------------------+
//|                            _TRO_TTM.mq4                          |
//|                             Copyright  2005, adoleh2000 and dwt5|
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//| Based on code offered at MT Yahoo group                          |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, adoleh2000"
#property link      "adoleh2000@yahoo.com"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 LimeGreen

//---- input parameters

extern int TTMperiod=6;

//---- buffers

double HighBuffer[];
double LowBuffer[];
double  Low_ma,
	     High_ma,
	     close, L3,H3;
double 	     Low_third[],
	     High_third[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   SetIndexBuffer(0,HighBuffer);

   string short_name;
   short_name="TRO_TTM";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);


//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(),i,shift;
   
if (counted_bars==0) counted_bars=TTMperiod+1;
i=(Bars-counted_bars);

for (shift=i; shift>=0;shift--)
{

Low_ma            = iMA(NULL,0,TTMperiod,0,MODE_EMA,PRICE_LOW,shift);
High_ma           = iMA(NULL,0,TTMperiod,0,MODE_EMA,PRICE_HIGH,shift);
close             = iClose(NULL,0,shift);


L3  = (High_ma- Low_ma) / 3 + Low_ma;
H3  = 2 * (High_ma- Low_ma) / 3 + Low_ma;

Low_third[shift]  = L3 ;
High_third[shift] = H3 ;

//Comment ("Low_third=",Low_third[shift],"; ","High_third=",High_third[shift]);

if (close > H3) {  HighBuffer[shift]= 1.0; } else {
if (close < L3)  {  HighBuffer[shift]= -1.0;} else { HighBuffer[shift]= 0.0; }  }
                              
                              
                                          
}

Comment( DoubleToStr(HighBuffer[shift] ,Digits ) );
  
  
   return(0);
  }
//+------------------------------------------------------------------+

